VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsBackup"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit


Private objSQL As SQLServer
Private WithEvents objBackup As Backup
Attribute objBackup.VB_VarHelpID = -1
Private WithEvents objRestore As Restore
Attribute objRestore.VB_VarHelpID = -1

Private mvarServerName As String
Private mvarLoginName As String
Private mvarPassword As String
Private mvarDatabaseName As String
Private mvarFileName As String
Private mError As String

Public Event PercentComplete(ByVal Message As String, ByVal Percent As Long)


Public Property Let FileName(ByVal vData As String)
    mvarFileName = vData
End Property


Public Property Get FileName() As String
    FileName = mvarFileName
End Property


Public Property Let DatabaseName(ByVal vData As String)
    mvarDatabaseName = vData
End Property


Public Property Get DatabaseName() As String
    DatabaseName = mvarDatabaseName
End Property


Public Property Let Password(ByVal vData As String)
    mvarPassword = vData
End Property


Public Property Get Password() As String
    Password = mvarPassword
End Property


Public Property Let LoginName(ByVal vData As String)
    mvarLoginName = vData
End Property


Public Property Get LoginName() As String
    LoginName = mvarLoginName
End Property


Public Property Let ServerName(ByVal vData As String)
    mvarServerName = vData
End Property


Public Property Get ServerName() As String
    ServerName = mvarServerName
End Property


Private Function ConnectDB() As Boolean
    On Error GoTo E
    ConnectDB = False
    Set objSQL = New SQLServer
    objSQL.Connect ServerName, LoginName, Password
    ConnectDB = True
    Exit Function
E:
    mError = Err.Description
End Function


Public Function GetLastError() As String
    GetLastError = mError
End Function


Public Function Backup() As Boolean
    On Error GoTo E
    Backup = False
    
    If Not ConnectDB Then Exit Function
    
    If DatabaseName = "" Then
        mError = "Database name cannot be empty"
        objSQL.DisConnect
        Exit Function
    End If
    
    If FileName = "" Then
        mError = "File name cannot be empty"
        objSQL.DisConnect
        Exit Function
    End If
    
    Set objBackup = New Backup
    With objBackup
        .Action = SQLDMOBackup_Database
        .Files = "[" & FileName & "]"
        .Database = DatabaseName
        .BackupSetName = "DBBackup"
        .BackupSetDescription = "Backup"
        RaiseEvent PercentComplete("", 0)
        .SQLBackup objSQL
    End With
  
    objSQL.DisConnect
    Backup = True
    Exit Function
E:
    mError = Err.Description
End Function


Private Sub objBackup_Complete(ByVal Message As String)
    ''
End Sub


Private Sub objBackup_NextMedia(ByVal Message As String)
    ''
End Sub


Private Sub objBackup_PercentComplete(ByVal Message As String, ByVal Percent As Long)
    RaiseEvent PercentComplete(Message, Percent)
End Sub


Public Function Restore() As Boolean
    On Error GoTo E
    Restore = False
    
    If Not ConnectDB Then Exit Function
    
    If DatabaseName = "" Then
        mError = "Database name cannot be empty"
        objSQL.DisConnect
        Exit Function
    End If
    
    If FileName = "" Then
        mError = "File name cannot be empty"
        objSQL.DisConnect
        Exit Function
    End If
    
    Set objRestore = New Restore
    With objRestore
        .Files = "[" & FileName & "]"
        .Database = DatabaseName
        .ReplaceDatabase = True
        RaiseEvent PercentComplete("", 0)
        .SQLRestore objSQL
    End With

    objSQL.DisConnect
    Restore = True
    Exit Function
E:
    mError = Err.Description
End Function


Private Sub objRestore_Complete(ByVal Message As String)
    ''
End Sub


Private Sub objRestore_NextMedia(ByVal Message As String)
    ''
End Sub


Private Sub objRestore_PercentComplete(ByVal Message As String, ByVal Percent As Long)
    RaiseEvent PercentComplete(Message, Percent)
End Sub


Private Function ShutdownSQL() As Boolean
    On Error GoTo E
    ShutdownSQL = False
    objSQL.Shutdown True
    ShutdownSQL = True
    Exit Function
E:
    mError = Err.Description
End Function


Private Function StartSQL() As Boolean
    On Error GoTo E
    StartSQL = False
    objSQL.Start True, ServerName, LoginName, Password
    StartSQL = True
    Exit Function
E:
    mError = Err.Description
End Function

